import win32.windows;
import win32frame.glut;
import std.stdio;
import core.thread;
import std.math;

import mt19937ar ;
import GameFrame;
import Sprite;
import SPformat;

import Vec3D;
import Quaternion;

import GameSequence;

class myGameFrame : GameFrame
{
  this(string name, string ClassName) {
    super(name, ClassName) ;
  }

  int DestroyProc(){
    return(0) ;
  }
  
  int GameLoop(){
    int    tick =0 ;
    int    fps ;
    Sprite    sp = cast(Sprite)(SP) ;
    GameInfo* gi = cast(GameInfo*)(&GmInfo) ;
    
    init_genrand(7777777) ;

    sp.init(512, 8192, 32, 8192, gi) ;
    sp.add3DPCG("3d_obj/board.obj",     0, 0.4) ;
    sp.add3DPCG("3d_obj/stone.obj",     1, 0.18) ;

    sp.add2DPCG("img_data/title.png",   0, true) ;
    sp.add2DPCG("img_data/youwin.png",  1, true) ;
    sp.add2DPCG("img_data/youlose.png", 2, true) ;
    sp.add2DPCG("img_data/draw.png",    3, true) ;
    
    int fonttop=32 ;
    sp.add2DPCG("img_data/font8x16.png",fonttop,  8,16,16,16,true) ;
    SPformat spformat = new SPformat(sp,fonttop,8,16) ;

    sp.setLight(0, 0.2, 0.5, 0.6, 1.0,   0.9, 0.9, 0.9,  0.8, 0.8, 0.8,  1.0, 1.0, 1.0) ;
    sp.setLightSpot(0, 0.0, 0.0, -1.0,      0.0, 180.0, 0.9, 0.0, 0.0) ;

    sp.setLight(1, -1.0, -0.5, 0.3, 1.0, 0.9, 0.9, 0.9,  0.8, 0.8, 0.8,  1.0, 1.0, 1.0) ;
    sp.setLightSpot(1, 0.0, 0.0, -1.0,      0.0, 180.0, 0.8, 0.0, 0.0) ;
    
    sp.setClearColor( 0.3, 0.3, 0.3 ) ;
    
    GameSequence gs = new GameSequence() ;
    gs.init(sp,gi) ;


    while(running==true){
      if( sp.resetSync()==0 ){

	gs.makeframe(sp,gi) ;
	
	fps=sp.getFPS() ;
	//spformat.print(0+8,0+8,"fps=%d tick=%d",fps,tick) ;
	//spformat.print(0+8,0+8+16,"OpenGL Version %s",getglversion()) ;
	//spformat.print(0+8,0+8+32,"%s",getglrenderer()) ;
	//spformat.print(0+8,0+8+48,"glext %s",getglextmsg()) ;
	//spformat.print(0+8,0+8+64,"mouse %d %d 0x%08x",gi.mousex, gi.mousey, gi.mouseb ) ;
	//spformat.print(0+8,0+8+80,"putpos %f %f",gs.putpos.x, gs.putpos.z ) ;
	//spformat.print(0+8,0+8+96,"putpos %d %d",gs.put_x, gs.put_y ) ;

	tick++ ;
      }
      sp.waitSync() ;
    }
    return(0) ;
  }

}
