import win32.windows;
import win32.windef;
import win32.commctrl;

import std.stdio;
import std.string;
import std.utf;
import std.file;

//
// Example:
//  string fname ;
//  fname = getLoadFileName("WaveFrontOBJ {*.obj}\0*.obj\0",parentHWND,OFN_HIDEREADONLY) ;
//

class FileDialog{

  this(){
  }

  string getSaveFileName(string filematch, HWND parentHWND, DWORD addflags=0){
    OPENFILENAME ofn ;
    wchar[]      wfname ;
    string       retstr ;
    string       curdir ;

    wfname.length=MAX_PATH ;
    wfname[0]=0 ;

    curdir=std.file.getcwd() ;
    
    ofn.lStructSize = OPENFILENAME.sizeof ;
    ofn.hwndOwner   = parentHWND ;
    if( filematch==null ){
      ofn.lpstrFilter = null ;
    }else{
      ofn.lpstrFilter = toUTFz!(wchar*)(filematch) ;
    }
    ofn.lpstrCustomFilter = null ;
    ofn.lpstrFile   = wfname.ptr ;
    ofn.nMaxFile    = MAX_PATH ;
    ofn.Flags       = addflags ;

    GetSaveFileName(&ofn) ;

    foreach( i, c ; wfname ){
      if( c==0 ){ wfname.length=i ; break ; }
    }
    
    retstr = std.utf.toUTF8(wfname.idup) ;

    std.file.chdir(curdir) ;
    
    return(retstr) ;
  }
  

  string getLoadFileName(string filematch, HWND parentHWND, DWORD addflags=0){
    OPENFILENAME ofn ;
    wchar[]      wfname ;
    string       retstr ;
    string       curdir ;

    wfname.length=MAX_PATH ;
    wfname[0]=0 ; //これが無いとGetOpenFileName()に失敗する

    curdir=std.file.getcwd() ;
    
    ofn.lStructSize = OPENFILENAME.sizeof ;
    ofn.hwndOwner   = parentHWND ;
    if( filematch==null ){
      ofn.lpstrFilter = null ;
    }else{
      ofn.lpstrFilter = toUTFz!(wchar*)(filematch) ;
    }
    ofn.lpstrCustomFilter = null ;
    ofn.lpstrFile   = wfname.ptr ;
    ofn.nMaxFile    = MAX_PATH ;
    ofn.Flags       = OFN_FILEMUSTEXIST | addflags ;

    GetOpenFileName(&ofn) ;

    foreach( i, c ; wfname ){
      if( c==0 ){ wfname.length=i ; break ;}
    }
    
    retstr = std.utf.toUTF8(wfname.idup) ;
    
    std.file.chdir(curdir) ;
    
    return(retstr) ;
  }
}  
