import win32.windows;
import win32.windef;
import win32.commctrl;
import win32frame.writek;
import win32frame.WindowObject;
import win32frame.Frame;
import win32frame.WindowMenu;
import win32frame.StatusBar ;
import win32frame.ToolBarEx;
import win32frame.Rebar;

import std.stdio;
import std.string;
import std.utf;

class MainWindow : Frame {
  Rebar  reBar ;
  int    rebarWidth  ;
  int    rebarHeight ;
  bool   with_rebar=false ;
  HWND[] bc_wmsize_List ; // WM_SIZEをブロードキャストするHWNDリスト

  this(string name, string ClassName) {
    super(name) ;
  }

  int withRebar(){
    with_rebar=true ;
    return(0) ;
  }

  bool setMenu(WindowMenu menu){
    return( cast(bool)( SetMenu(this.getHWND() , menu.getHMENU()) ) ) ;
  }

  int setMainWinHWND(){
    if( MainWindowHWND==null ){
      MainWindowHWND=cast(shared HWND)(this.getHWND()) ;
      return(0) ;
    }
    return(-1) ;
  }
  
  int setREBARBANDINFO(REBARBANDINFO rbbi){
    if( with_rebar==true ){
      if( reBar !is null ){
	return(reBar.setREBARBANDINFO(rbbi)) ;
      }
    }
    return(-1) ;
  }
  
  int addonRebar(WindowObject WObj){
    if( with_rebar==false ) return(-1) ;
    return( reBar.addWindowObject(WObj) ) ;
  }

  int addonRebar(ToolBarEx toolbar){
    if( with_rebar==false ) return(-1) ;
    return( reBar.addTool(toolbar) ) ;
  }

  int addStatusBar(StatusBar StBar, string msg){
    HWND stbhwnd ;
    int  ret ;
    ret = StBar.create(this.getHWND(), msg) ;
    stbhwnd = StBar.getHWND() ;
    if( stbhwnd != null ){
      bc_wmsize_List.length = bc_wmsize_List.length+1 ;
      bc_wmsize_List[(bc_wmsize_List.length-1)]=stbhwnd ;
      _statusBar = cast(shared StatusBar)(StBar) ;
    }
    return( ret ) ;
  }

  override LRESULT preproc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    switch( msg ){
    case WM_CREATE:
      if( with_rebar==true ){
	reBar = new Rebar("Rebar") ;
	addObject(reBar, null, true, true) ;
      }
      setMainWinHWND() ;
      break ;

    case WM_NOTIFY :
      LPNMHDR lpnmhdr ;
      lpnmhdr = cast(LPNMHDR)(lp) ;
      if( with_rebar==true ){
	if( lpnmhdr.hwndFrom == reBar.getHWND() ){
	  if( lpnmhdr.code == RBN_HEIGHTCHANGE){
	    InvalidateRect(hwnd, null, true) ;
	    UpdateWindow(reBar.getHWND()) ;
	    RECT rc ;
	    GetClientRect( reBar.getHWND(), &rc ) ;
	    rebarHeight = rc.bottom - rc.top +2 ;
	    GetWindowRect(hwnd, &rc ) ;
	    sendmsg(WM_SIZE, 0, ((rc.right - rc.left)<<16 | (rc.bottom - rc.top)) ) ;
	  }
	}
      }
      break ;
      
    case WM_MOVE :
      winX=LOWORD(lp) ;
      winY=HIWORD(lp) ;
      break ;

    case WM_SIZE :
      winW=LOWORD(lp) ;
      winH=HIWORD(lp) ;
      
      RECT rc ;
      GetClientRect( hwnd, &rc ) ;
      if( _statusBar !is null ){
	RECT rc_statbar ;
        StatusBar statbar = cast(StatusBar)(_statusBar) ;
        GetWindowRect( statbar.getHWND(), &rc_statbar ) ;	
	rc.bottom -= ((rc_statbar.bottom - rc_statbar.top)+2) ;
      }
      foreach_reverse( i, fitWOBJ ; fitWOBJ_List ){
	if( fitWOBJ !is null ){
	  
	  if( with_rebar==true ){
	    if( reBar.getHWND() == fitWOBJ.getHWND() ){
	      MoveWindow( reBar.getHWND(), 0, 0, (rc.right - rc.left), (rc.bottom - rc.top), false ) ;
	      InvalidateRect( reBar.getHWND(), null, true ) ;
	    }else{
	      switch( fitWOBJ_Flag[fitWOBJ] ){
	      case 1 : // fit Width
		MoveWindow( fitWOBJ.getHWND(), 0, fitWOBJ.winY+rebarHeight+2, (rc.right - rc.left), fitWOBJ.winH, true ) ;
		break ;
	      case 2 : // fit Height
		MoveWindow( fitWOBJ.getHWND(), fitWOBJ.winX, rebarHeight+2, fitWOBJ.winW, (rc.bottom - rc.top) - rebarHeight, true ) ;
		break ;
	      case 3 :
		MoveWindow( fitWOBJ.getHWND(), 0, rebarHeight+2, (rc.right - rc.left), (rc.bottom - rc.top) - rebarHeight, true ) ;
		break ;
	      default : core.exception.onSwitchError() ;
	      }
	    }
	  }else{
	    switch( fitWOBJ_Flag[fitWOBJ] ){
	    case 1 : // fit Width
	      MoveWindow( fitWOBJ.getHWND(), 0, fitWOBJ.winY, (rc.right - rc.left), fitWOBJ.winH , true ) ;
	      break ;
	    case 2 : // fit Height
	      MoveWindow( fitWOBJ.getHWND(), fitWOBJ.winX, 0, fitWOBJ.winW, (rc.bottom - rc.top) , true ) ;
	      break ;
	    case 3 :
	      MoveWindow( fitWOBJ.getHWND(), 0,0, (rc.right - rc.left), (rc.bottom - rc.top) , true ) ;
	      break ;
	    default : core.exception.onSwitchError() ;
	    }
	  }
	}
      }
      foreach_reverse( i, bc_wmsize ; bc_wmsize_List ){
	sendmsg( bc_wmsize, WM_SIZE, wp, lp);
      }
      break ;
      
    default : break ;
    }
    
    return( this.proc(hwnd , msg , wp , lp) ) ;
  }
}
