import win32.windows;
import win32.commctrl;
import std.stdio;
import std.string;
import std.utf;
import win32frame.writek;
import win32frame.CommonControl;
import win32frame.WindowObject ;

uint MAKELPARAM(ushort a, ushort b) { return cast(uint) ((b << 16) | a); }
uint INDEXTOSTATEIMAGEMASK(uint i)  { return i << 12; }

class TreeView : WindowObject {
  
  this(string name) {
    CommonControl cc = new CommonControl() ;
    winc.lpszClassName  = toUTFz!(wchar*)(WC_TREEVIEW) ;
    setStyle( (WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN) ) ;
    super(name) ;
  }


  HTREEITEM insertItem(LPTVINSERTSTRUCT i) { //TreeView_InsertItem(LPTVINSERTSTRUCT i) {
    return( cast(HTREEITEM)(sendmsg(TVM_INSERTITEM, 0, cast(LPARAM)(i))) ) ;
  }

  bool deleteItem(HTREEITEM i) { //TreeView_DeleteItem(HTREEITEM i) {
    return( cast(bool)(sendmsg(TVM_DELETEITEM, 0, cast(LPARAM)(i))) ) ;
  }

  bool deleteAllItems() { //TreeView_DeleteAllItems() {
    return( cast(bool)(sendmsg(TVM_DELETEITEM, 0, cast(LPARAM)(TVI_ROOT))) ) ;
  }

  bool expand(HTREEITEM i, UINT c) { //TreeView_Expand(HTREEITEM i, UINT c) {
    return( cast(bool)(sendmsg(TVM_EXPAND, c, cast(LPARAM)(i))) ) ;
  }

  bool getItemRect(HTREEITEM i, LPRECT p, BOOL c) { //TreeView_GetItemRect(HTREEITEM i, LPRECT p, BOOL c) {
    *cast(HTREEITEM*)(p) = i;
    return( cast(bool)(sendmsg(TVM_GETITEMRECT, c, cast(LPARAM)(p))) ) ;
  }

  uint getCount() { //TreeView_GetCount() {
    return( cast(uint)(sendmsg(TVM_GETCOUNT, 0, 0)) ) ;
  }

  uint getIndent() { //TreeView_GetIndent() {
    return( cast(uint)(sendmsg(TVM_GETINDENT, 0, 0)) ) ;
  }

  bool setIndent(int i) { //TreeView_SetIndent(int i) {
    return( cast(bool)(sendmsg(TVM_SETINDENT, i, 0)) ) ;
  }

  HIMAGELIST getImageList(int i) { //TreeView_GetImageList(int i) {
    return( cast(HIMAGELIST)(sendmsg(TVM_GETIMAGELIST, i, 0)) ) ;
  }

  HIMAGELIST setImageList(HIMAGELIST h, INT i) { //TreeView_SetImageList(HIMAGELIST h, INT i) {
    return( cast(HIMAGELIST)(sendmsg(TVM_SETIMAGELIST, i, cast(LPARAM)(h))) ) ;
  }

  HTREEITEM getNextItem(HTREEITEM i, UINT c) { //TreeView_GetNextItem(HTREEITEM i, UINT c) {
    return( cast(HTREEITEM)(sendmsg(TVM_GETNEXTITEM, c, cast(LPARAM)(i))) ) ;
  }

  HTREEITEM getChild(HTREEITEM i) { //TreeView_GetChild(HTREEITEM i) {
    return( getNextItem(i, TVGN_CHILD) ) ; 
  }

  HTREEITEM getNextSibling(HTREEITEM i) { //TreeView_GetNextSibling(HTREEITEM i) {
    return( getNextItem(i, TVGN_NEXT) ) ;
  }

  HTREEITEM getPrevSibling(HTREEITEM i) { //TreeView_GetPrevSibling(HTREEITEM i) {
    return( getNextItem(i, TVGN_PREVIOUS) ) ;
  }

  HTREEITEM getParent(HTREEITEM i) { //TreeView_GetParent(HTREEITEM i) {
    return( getNextItem(i, TVGN_PARENT) ) ;
  }

  HTREEITEM getFirstVisible() { //TreeView_GetFirstVisible() {
    return( getNextItem(null, TVGN_FIRSTVISIBLE) ) ;
  }

  HTREEITEM getNextVisible(HTREEITEM i) { //TreeView_GetNextVisible(HTREEITEM i) {
    return( getNextItem(i, TVGN_NEXTVISIBLE) ) ;
  }

  HTREEITEM getPrevVisible(HTREEITEM i) { //TreeView_GetPrevVisible(HTREEITEM i) {
    return( getNextItem(i, TVGN_PREVIOUSVISIBLE) ) ;
  }

  HTREEITEM getSelection() { //TreeView_GetSelection() {
    return( getNextItem(null, TVGN_CARET) ) ;
  }

  HTREEITEM getDropHilight(HTREEITEM w) { //TreeView_GetDropHilight(HTREEITEM w) {
    return( cast(HTREEITEM)(sendmsg(cast(HWND)(w), TVM_GETNEXTITEM, TVGN_DROPHILITE, cast(LPARAM)(null))) ) ;
  }

  HTREEITEM getRoot() { //TreeView_GetRoot() {
    return( getNextItem(null, TVGN_ROOT) ) ;
  }

  bool select(HTREEITEM i, uint c) { //TreeView_Select(HTREEITEM i, uint c) {
    return( cast(bool)(sendmsg(TVM_SELECTITEM, c, cast(LPARAM)(i))) ) ;
  }

  bool selectItem(HTREEITEM i) { //TreeView_SelectItem(HTREEITEM i) {
    return( select(i, TVGN_CARET) ) ;
  }

  bool selectDropTarget(HTREEITEM i) { //TreeView_SelectDropTarget(HTREEITEM i) {
    return( select(i, TVGN_DROPHILITE) ) ;
  }

  bool selectSetFirstVisible(HTREEITEM i) { //TreeView_SelectSetFirstVisible(HTREEITEM i) {
    return( select(i, TVGN_FIRSTVISIBLE) ) ;
  }

  bool getItem(LPTVITEM i) { //TreeView_GetItem(LPTVITEM i) {
    return( cast(bool)(sendmsg(TVM_GETITEM, 0, cast(LPARAM)(i))) ) ;
  }

  bool setItem(LPTVITEM i) { //TreeView_SetItem(LPTVITEM i) {
    return( cast(bool)(sendmsg(TVM_SETITEM, 0, cast(LPARAM)(i))) ) ;
  }

  HWND editLabel(HTREEITEM i) { //TreeView_EditLabel(HTREEITEM i) {
    return( cast(HWND)(sendmsg(TVM_EDITLABEL, 0, cast(LPARAM)(i))) ) ;
  }

  HWND getEditControl() { //TreeView_GetEditControl() {
    return( cast(HWND)(sendmsg(TVM_GETEDITCONTROL, 0, 0)) ) ;
  }

  uint getVisibleCount() { //TreeView_GetVisibleCount() {
    return( cast(uint)(sendmsg(TVM_GETVISIBLECOUNT, 0, 0)) ) ;
  }

  HTREEITEM hitTest(LPTVHITTESTINFO p) { //TreeView_HitTest(LPTVHITTESTINFO p) {
    return( cast(HTREEITEM)(sendmsg(TVM_HITTEST, 0, cast(LPARAM)(p))) ) ;
  }

  HIMAGELIST createDragImage(HTREEITEM i) { //TreeView_CreateDragImage(HTREEITEM i) {
    return( cast(HIMAGELIST)(sendmsg(TVM_CREATEDRAGIMAGE, 0, cast(LPARAM)(i))) ) ;
  }

  bool sortChildren(HTREEITEM i, bool r) { //TreeView_SortChildren(HTREEITEM i, bool r) {
    return( cast(bool)(sendmsg(TVM_SORTCHILDREN, r, cast(LPARAM)(i))) ) ;
  }

  bool ensureVisible(HTREEITEM i) { //TreeView_EnsureVisible(HTREEITEM i) {
    return( cast(bool)(sendmsg(TVM_ENSUREVISIBLE, 0, cast(LPARAM)(i))) ) ;
  }

  bool sortChildrenCB(LPTVSORTCB s, bool r) { //TreeView_SortChildrenCB(LPTVSORTCB s, bool r) {
    return( cast(bool)(sendmsg(TVM_SORTCHILDRENCB, r, cast(LPARAM)(s))) ) ;
  }

  bool endEditLabelNow(bool f) { //TreeView_EndEditLabelNow(bool f) {
    return( cast(bool)(sendmsg(TVM_ENDEDITLABELNOW, f, 0)) ) ;
  }

  bool getISearchString(LPTSTR s) { //TreeView_GetISearchString(LPTSTR s) {
    return( cast(bool)(sendmsg(TVM_GETISEARCHSTRING, 0, cast(LPARAM)(s))) ) ;
  }

}

